///////////////////////////////////////////////////////////////////////
// DemoRtos.h

#ifndef DEMORTOS_H
#define DEMORTOS_H

#define MAXTASKS		10
#define MAXSEMAPHORES	10
#define MAXTIMERS		10

typedef enum 
{
	stOK,
	stNO_HANDLE,
	stTIMEOUT

} TSTATUS;

typedef enum
{
	taTASK_SUSPENDED,
	taTASK_WAITING,
	taTASK_SEMA_WAIT,
	taTASK_RUNNING

} TTaskState;

typedef CArray<CString, CString&> TTaskStateName;

typedef enum
{
	tiTIMER_STOPPED,
	tiTIMER_RUNNING

} TTimerState;

typedef CArray<CString, CString&> TTimerStateName;

typedef WORD pchar16;
typedef WORD int16;
typedef WORD ADDR16;
typedef WORD TFptr16;
typedef WORD TTaskState16;
typedef WORD pvoid16;
typedef WORD pttask16;
typedef WORD TTimerState16;

typedef struct
{
	pchar16		Name;
	int16		Handle;
	int16		Index;
	TFptr16		Fptr;
	TFptr16		Pc;
	ADDR16		Sp;
	ADDR16		Saveaddr;
	ADDR16		SpAddr;
	int16		StartOver;
	TTaskState16 State;
	int16		WaitTime;	
	int16		WaitReturn;
	pvoid16		Timer;
	pvoid16		Semaphore;

} TTask16;

typedef struct
{
	pchar16		Name;
	int16		Handle;
	int16		Value;
	int16		MaxValue;
	pttask16	Queue[MAXTASKS];

} TSema16;

typedef struct
{
	pchar16		Name;
	int16		Handle;
	int16		Value;
	int16		Cnt;
	TTimerState16 State;
	pttask16	Task;

} TTimer16;

typedef struct
{
	int16		MaxTasks;
	int16		MaxSemas;
	int16		MaxTimers;
	TTask16		TaskArray[MAXTASKS];
	TSema16		SemaArray[MAXSEMAPHORES];
	TTimer16	TimerArray[MAXTIMERS];
	pttask16	RunningTask;
	int16		temp;

} TApp16;

extern char* TaskStateName[];
extern char* TimerStateName[];

#endif
